// The function takes two arguments, selection and props.
export const dropdownmenu = (selection, props) => {
	const {
  	options,
  	onOptionClicked,
  	selectedOption} = props;
// The function selects or appends a select element to represent the dropdown menu.
// onOptionClicked is called with the new selected option as an argument.  
  let select = selection.selectAll('select').data([null]);
  select = select.enter().append('select')
    	.merge(select)
  			.on('change', function() {
  				onOptionClicked(this.value);
  	});
// The function binds the options array to the option elements to populate the dropdown menu with the available options.   
  const option = select.selectAll('option').data(options);
// The function sets the text content of each option element to be the value of the corresponding option in the options array.  
  option.enter()
    .append('option')
    .merge(option)
  		.attr('value', d => d)
  		.property('selected', d => d === selectedOption)
  		.text(d => d);
};
