// Importing the packages select,csv,scaleLinear,extent,axisLeft,axisBottom from d3 library.
import { 
  select, 
  csv, 
  scaleLinear, 
  extent,  
  axisLeft,
  axisBottom
} from 'd3';
// these libraries used for creating dropdown in the scatterplot.
import { dropdownmenu } from './dropdownMenu';
import {scatterPlot } from './scatterplot';


const svg = select('svg');
//const height = +svg.attr('height');
//const width = +svg.attr('width');
//const circleRadius = 8;


//d.mpg = +d.mpg;
//      d.cylinders = +d.cylinders;
 //     d.displacement = +d.displacement;
 //     d.horsepower = +d.horsepower;
  //    d.weight = +d.weight;
 //     d.acceleration = +d.acceleration;
  //    d.year = +d.year;
let data;
let xColumn;
let yColumn;

const onXColumnClicked = column => {
    xColumn = column;
  	render();
};

const onyColumnClicked = column => {
    yColumn = column;
  	render();
};

const render = () => {
  
select('#x-menu').call(dropdownmenu, {
    options: data.columns,
    onOptionClicked: onXColumnClicked,
  	selectedOption: xColumn
  });
  
select('#y-menu').call(dropdownmenu, {
    options: data.columns,
    onOptionClicked: onyColumnClicked,
  	selectedOption: yColumn
  });
 // The code defines variables xColumn and yColumn to store the selected x-axis and y-axis column names, respectively. 
  svg.call(scatterPlot, {
    				xValue: d => d[xColumn],
  					xAxisLabel: xColumn,
            yValue:d => d[yColumn],
            yAxisLabel: yColumn,
    				circleRadius: 8,
            margin: { top: 10, right: 50, bottom: 75, left: 200 },
    				width: +svg.attr('width'),
  					height: +svg.attr('height'),
    				data
           });
  
};
// load the data from the csv file
csv('https://gist.githubusercontent.com/Swapna1915/c15b058cf9e971454be7e972dc5ea871/raw/97e8a33ef71965fe88e96e87a37a9e66d2892b26/vehiclepartscomparison.csv')
  .then(loadeddata => {
  	data = loadeddata;
    data.forEach(d => {
      d.mpg = +d.mpg;
      d.cylinders = +d.cylinders;
      d.displacement = +d.displacement;
      d.horsepower = +d.horsepower;
      d.weight = +d.weight;
      d.acceleration = +d.acceleration;
      d.year = +d.year;
  });
  xColumn = data.columns[4];
  yColumn = data.columns[0];
  render();
});